#!/bin/bash
IP=$1
echo "Configuring certs for CN $1"
openssl genrsa -aes256 -passout pass:1234 -out server.pass.key 4096
openssl rsa -passin pass:1234 -in server.pass.key -out ca-key.pem

openssl req -new -x509 -days 365 -key ca-key.pem -sha256 -out ca.pem \
  -subj "/C=IT/ST=Italy/L=Italy/O=decide/OU=IT Department/CN=$1"

openssl genrsa -out server-key.pem 4096

openssl req -subj "/C=IT/ST=Italy/L=Italy/O=decide/OU=IT Department/CN=$1" -sha256 -new -key server-key.pem -out server.csr

echo subjectAltName = DNS:decide.org,IP:$1,IP:127.0.0.1 > extfile.cnf
openssl x509 -req -days 365 -sha256 -passin pass:1234 -in server.csr -CA ca.pem -CAkey ca-key.pem \
  -CAcreateserial -out server-cert.pem -extfile extfile.cnf

rm -v server.csr server.pass.key

sudo chmod -R 777 /decide/.docker
sudo rm -r /decide/.docker

sudo mkdir -pv /decide/.docker/server/keys
sudo mkdir -pv /decide/.docker/client/keys

sudo cp -v {ca,server-cert,server-key}.pem /decide/.docker/server/keys

sudo mkdir -pv /tmp/scripts/tempkeys
sudo cp -v {ca,server-cert,server-key}.pem /tmp/scripts/tempkeys

sudo chmod -v 0400 /decide/.docker/server/keys/*-key.pem
sudo chmod -v 0444 /decide/.docker/server/keys/{ca,server-cert}.pem

openssl genrsa -out key.pem 4096
openssl req -subj '/CN=client' -new -key key.pem -out client.csr
echo extendedKeyUsage = clientAuth > extfile.cnf
openssl x509 -req -days 365 -sha256 -passin pass:1234 -in client.csr -CA ca.pem -CAkey ca-key.pem \
  -CAcreateserial -out cert.pem -extfile extfile.cnf

rm -v client.csr ca.srl

#Configure docker secure by default on port 8376
sudo cp -v {ca,cert,key}.pem /decide/.docker/client/keys
sudo cp -v {ca,cert,key}.pem /tmp/scripts/tempkeys
sudo chmod -v 0400 /decide/.docker/client/keys/key.pem
sudo chmod -v 0444 /decide/.docker/client/keys/cert.pem
rm -v *.pem
export DOCKER_HOST=tcp://$IP:8376 DOCKER_TLS_VERIFY=1
export DOCKER_CERT_PATH=/decide/.docker/client/keys
echo "export DOCKER_HOST=tcp://$IP:8376 DOCKER_TLS_VERIFY=1" >> $HOME/.bashrc
echo "export DOCKER_CERT_PATH=/decide/.docker/client/keys" >> $HOME/.bashrc
