#!/bin/bash

while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done
sudo apt-get install \
    apt-transport-https \
    ca-certificates \
    curl \
    software-properties-common -y

curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -

while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done

sudo add-apt-repository \
   "deb [arch=amd64] https://download.docker.com/linux/ubuntu \
   $(lsb_release -cs) \
   stable"
   
while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done

sudo apt-get update -y

while fuser /var/lib/dpkg/lock >/dev/null 2>&1 ; do
  echo "...waiting for /var/lib/dpkg/lock unlock... " >> /tmp/scripts/install.log
  sleep 0.5
done

sudo mkdir -p /decide/.docker/server/keys/
sudo mkdir -p /decide/.docker/client/keys/

sudo apt-get install docker-ce -y

sudo curl -o /usr/local/bin/docker-compose -L "https://github.com/docker/compose/releases/download/1.11.2/docker-compose-$(uname -s)-$(uname -m)"
sudo chmod +x /usr/local/bin/docker-compose
sudo docker-compose -v
