#!/bin/bash

# What you need:
#- jq tool 
#- ip address and port of the ADAPT DO node
#- application name
#- filepath of the private ssh key to set in the nodes to allow ssh passworldless
#- the json body to POST to enpoints (as for the ADAPT DO REST API)
#- APPLY: define if really apply the terraform actions or just plan them 

. ./params.txt

./upload-cert.sh

##############
echo "Preparing configuration environment for Terraform..."
echo "curl -s -X POST -H 'Content-Type: application/json' --data @$PREPARATION_JSON http://$ADAPT_IP:$ADAPT_PORT/terraform/all | $JQ_HOME/jq -r '.result'"
RESULT=`curl -s -X POST -H 'Content-Type: application/json' --data @$PREPARATION_JSON http://$ADAPT_IP:$ADAPT_PORT/terraform/all | $JQ_HOME/jq -r '.result'`

if [ "$RESULT" != "success" ]; then
    echo "Error in POST operation. Exiting"
    exit 1
fi

./upload-sshkey.sh

#############
echo "Initializing infrastructure"
RESULT_URL=`curl -s -H "Content-Type: application/json" -X POST --data @$PREPARATION_JSON http://$ADAPT_IP:$ADAPT_PORT/terraform/init/$APPLICATION_NAME/infrastructure | $JQ_HOME/jq -r '.get_result_url'`

if [ -z "$RESULT_URL" ]; then
    echo "Error in POST operation. Exiting"
    exit 1
fi

RESULT=`curl -s $RESULT_URL | $JQ_HOME/jq -r '.result'`
while [ "$RESULT" == "running" ]; do
    sleep 2
    echo "Checking result..."
    RESULT=`curl -s $RESULT_URL | $JQ_HOME/jq -r '.result'`
    echo "Result: $RESULT"
done

if [ "$RESULT" != "success" ]; then
    echo "Error in POST operation. Exiting"
    exit 1
fi

##############
echo "Creating infrastructure deployment plan"
RESULT_URL=`curl -s -H "Content-Type: application/json" -X POST --data @$PREPARATION_JSON http://$ADAPT_IP:$ADAPT_PORT/terraform/plan/$APPLICATION_NAME/infrastructure | $JQ_HOME/jq -r '.get_result_url'`

if [ -z "$RESULT_URL" ]; then
    echo "Error in POST operation. Exiting"
    exit 1
fi

RESULT=`curl -s $RESULT_URL | $JQ_HOME/jq -r '.result'`
while [ "$RESULT" == "running" ]; do
    sleep 2
    echo "Checking result..."
    RESULT=`curl -s $RESULT_URL | $JQ_HOME/jq -r '.result'`
    echo "Result: $RESULT"
done

if [ "$RESULT" != "success" ]; then
    echo "Error in POST operation. Exiting"
    exit 1
fi

##############
if $APPLY ; then
        echo "Applying infrastructure deployment plan"
        RESULT_URL=`curl -s -H "Content-Type: application/json" -X POST --data @$PREPARATION_JSON http://$ADAPT_IP:$ADAPT_PORT/terraform/apply/$APPLICATION_NAME/infrastructure | $JQ_HOME/jq -r '.get_result_url'`

        if [ -z "$RESULT_URL" ]; then
                echo "Error in POST operation. Exiting"
                exit 1
        fi

        RESULT=`curl -s $RESULT_URL | $JQ_HOME/jq -r '.result'`
        while [ "$RESULT" == "running" ]; do
                sleep 2
                echo "Checking result..."
                RESULT=`curl -s $RESULT_URL | $JQ_HOME/jq -r '.result'`
                echo "Result: $RESULT"
        done

        if [ "$RESULT" != "success" ]; then
                echo "Error in POST operation. Exiting"
                exit 1
        fi
fi




echo "Infrastructure successfully deployed for app $APPLICATION_NAME!"




